SECTION "cvmial"

GET "libhdr"

MANIFEST $(
// MIAL op codes and directives

f_lp=      1
f_lg=      2
f_ll=      3

f_llp=     4
f_llg=     5
f_lll=     6
f_lf=      7
f_lw=      8

f_l=      10
f_lm=     11

f_sp=     12
f_sg=     13
f_sl=     14

f_ap=     15
f_ag=     16
f_a=      17
f_s=      18

f_lkp=    20
f_lkg=    21
f_rv=     22
f_rvp=    23
f_rvk=    24
f_st=     25
f_stp=    26
f_stk=    27
f_stkp=   28
f_stkg=   29
f_xst=    30

f_stb=    31
f_lvind=  32
f_indb=   33
f_indb0=  34
f_indw=   35

f_k=      36
f_kpg=    37

f_neg=    38
f_not=    39
f_abs=    40

f_xdiv=   41
f_xmod=   42
f_xsub=   43

f_mul=    45
f_div=    46
f_mod=    47
f_add=    48
f_sub=    49

f_eq=     50
f_ne=     51
f_ls=     52
f_gr=     53
f_le=     54
f_ge=     55
f_eq0=    56
f_ne0=    57
f_ls0=    58
f_gr0=    59
f_le0=    60
f_ge0=    61

f_lsh=    65
f_rsh=    66
f_and=    67
f_or=     68
f_xor=    69
f_lshk=   70
f_rshk=   71

f_xch=    80
f_atb=    81
f_atc=    82
f_bta=    83
f_btc=    84
f_cta=    85
f_atblp=  86
f_atblg=  87
f_atbll=  88
f_atbl=   89

f_j=      90
f_rtn=    91

f_ikp=    93
f_ikg=    94
f_ikl=    95
f_ip=     96
f_ig=     97
f_il=     98

f_jeq=    100
f_jne=    101
f_jls=    102
f_jgr=    103
f_jle=    104
f_jge=    105
f_jeq0=   106
f_jne0=   107
f_jls0=   108
f_jgr0=   109
f_jle0=   110
f_jge0=   111

f_brk=    120
f_nop=    121
f_chgco=  122
f_mdiv=   123
f_sys=    124

f_inc1b=  130
f_inc4b=  131
f_dec1b=  132
f_dec4b=  133
f_inc1a=  134
f_inc4a=  135
f_dec1a=  136
f_dec4a=  137

f_hand =  140
f_unh  =  141
f_raise=  142

f_module=   150
f_modstart= 151
f_modend=   152
f_global=   153

f_const=    155

f_lab=      157
f_entry=    158

f_dlab=     160
f_dw=       161
f_db=       162
f_dl=       163
f_ds=       164
$)

MANIFEST $(  // sial opcodes and directives
s_1=      1  // Used in the run length encoding scheme
s_2=      2  // in compacted sial

s_lp=     3
s_lg=     4
s_ll=     5

s_llp=    6
s_llg=    7
s_lll=    8
s_lf=     9
s_lw=     10

s_l=      11
s_lm=     12

s_sp=     13
s_sg=     14
s_sl=     15

s_ap=     16
s_ag=     17
s_a=      18
s_s=      19

s_lkp=    20
s_lkg=    21
s_rv=     22
s_rvp=    23
s_rvk=    24
s_st=     25
s_stp=    26
s_stk=    27
s_stkp=   28
s_skg=    29
s_xst=    30

s_k=      31
s_kpg=    32

s_neg=    33
s_not=    34
s_abs=    35

s_xdiv=   36
s_xrem=   37
s_xsub=   38

s_mul=    39
s_div=    40
s_rem=    41
s_add=    42
s_sub=    43

s_eq=     44
s_ne=     45
s_ls=     46
s_gr=     47
s_le=     48
s_ge=     49
s_eq0=    50
s_ne0=    51
s_ls0=    52
s_gr0=    53
s_le0=    54
s_ge0=    55

s_lsh=    56
s_rsh=    57
s_and=    58
s_or=     59
s_xor=    60
s_eqv=    61

s_gbyt=   62
s_xgbyt=  63
s_pbyt=   64
s_xpbyt=  65

s_swb=    66
s_swl=    67

s_xch=    68
s_atb=    69
s_atc=    70
s_bta=    71
s_btc=    72
s_atblp=  73
s_atblg=  74
s_atbl=   75

s_j=      76
s_rtn=    77
s_goto=   78

s_ikp=    79
s_ikg=    80
s_ikl=    81
s_ip=     82
s_ig=     83
s_il=     84

s_jeq=    85
s_jne=    86
s_jls=    87
s_jgr=    88
s_jle=    89
s_jge=    90
s_jeq0=   91
s_jne0=   92
s_jls0=   93
s_jgr0=   94
s_jle0=   95
s_jge0=   96
s_jge0m=  97

s_brk=    98
s_nop=    99
s_chgco=  100
s_mdiv=   101
s_sys=    102

s_section=  103
s_modstart= 104
s_modend=   105
s_global=   106
s_string=   107
s_const=    108
s_static=   109
s_mlab=     110
s_lab=      111
s_lstr=     112
s_entry=    113

s_float=    114
s_fix=      115
s_fabs=     116
s_fmul=     117
s_fdiv=     118
s_fadd=     119
s_fsub=     120
s_fneg=     121

s_feq=      122
s_fne=      123
s_fls=      124
s_fgr=      125
s_fle=      126
s_fge=      127
$)

GLOBAL $(
mialin:   200
asmout:   201
stdin:    202
stdout:   203

rdf:      210
rdp:      211
rdg:      212
rdk:      213
rdw:      215
rdl:      216
rdc:      218
rdcode:   219

pval:     220
gval:     221
kval:     222
wval:     224
lval:     225
mval:     226

scan:     230
cvf:      231
cvfp:     232
cvfg:     233
cvfk:     234
cvfw:     236
cvfl:     237

modname:  250
modletter:251
charv:    252
labnumber:253
$)

LET start() = VALOF
$( LET argv = VEC 20
   LET v    = VEC 20
   LET cv   = VEC 256/bytesperword

   modname := v
   modname%0 := 0
   modletter := 'A'
   charv := cv
   labnumber := 0

   asmout := 0
   stdout := output()
   IF rdargs("FROM,TO/K", argv, 20)=0 DO
   $( writes("Bad args for mial-sial*n")
      RESULTIS 20
   $)
   IF argv!0=0 DO argv!0 := "MIAL"
   IF argv!1=0 DO argv!1 := "**"
   mialin := findinput(argv!0)
   IF mialin=0 DO
   $( writef("Trouble with file %s*n", argv!0)
      RESULTIS 20
   $)
   asmout := findoutput(argv!1)
 //asmout := sysout
   
   IF asmout=0 DO
   $( writef("Trouble with file %s*n", argv!1)
      RESULTIS 20
   $)
   
   selectinput(mialin)
   selectoutput(asmout)

   scan()
   endread()
   UNLESS asmout=stdout DO endwrite()
   selectoutput(stdout)

   RESULTIS 0
$)

AND nextlab() = VALOF
{ labnumber := labnumber+1
  RESULTIS labnumber
}

// argument may be of form Ln
AND rdcode(let) = VALOF
$( LET a, ch, neg = 0, ?, FALSE

   ch := rdch() REPEATWHILE ch='*s' | ch='*n'

   IF ch=endstreamch RESULTIS -1

   UNLESS ch=let DO error("Bad item, looking for %c found %c*n", let, ch)

   ch := rdch()

   IF ch='-' DO { neg := TRUE; ch := rdch() }

   WHILE '0'<=ch<='9' DO $( a := 10*a + ch - '0'; ch := rdch()  $)

   RESULTIS neg -> -a, a
$)

AND rdf() = rdcode('F')
AND rdp() = VALOF { pval := rdcode('P'); RESULTIS pval }
AND rdg() = VALOF { gval := rdcode('G'); RESULTIS gval }
AND rdk() = VALOF { kval := rdcode('K'); RESULTIS kval }
AND rdw() = VALOF { wval := rdcode('W'); RESULTIS wval }
AND rdl() = VALOF { lval := rdcode('L'); RESULTIS lval }
AND rdm() = VALOF { mval := rdcode('M'); RESULTIS mval }
AND rdc() = rdcode('C')

AND error(mess, a, b, c) BE
$( LET out = output()
   UNLESS out=stdout DO
   $( selectoutput(stdout)
      writef(mess, a, b, c)
      selectoutput(out)
   $)
   writef(mess, a, b, c)
$)

AND scan() BE
$( LET op = rdf()

//	writef("	op=%n*n", op)
   SWITCHON op INTO

   $( DEFAULT:       error("# Bad op %n*n", op); LOOP

      CASE -1:       RETURN
      
      CASE f_lp:     cvfp(s_lp)		// a := P!n
                     ENDCASE
      CASE f_lg:     cvfg(s_lg)		// a := G!n
                     ENDCASE
      CASE f_ll:     cvfl(s_ll)		// a := !Ln
                     ENDCASE

      CASE f_llp:    cvfp(s_llp)	// a := @ P!n
                     ENDCASE
      CASE f_llg:    cvfg(s_llg)	// a := @ G!n
                     ENDCASE
      CASE f_lll:    cvfl(s_lll)	// a := @ !Ln
                     ENDCASE
      CASE f_lf:     cvfl(s_lf)		// a := byte address of Ln
                     ENDCASE
      CASE f_l:      cvfk(s_l)		// a := n
                     ENDCASE
      CASE f_lm:     cvfk(s_lm)		// a := -n
                     ENDCASE
      CASE f_lw:     cvfm(s_lw)
                     ENDCASE

      CASE f_sp:     cvfp(s_sp)		// P!n := a
                     ENDCASE
      CASE f_sg:     cvfg(s_sg)		// G!n := a
                     ENDCASE
      CASE f_sl:     cvfl(s_sl)		// !Ln := a
                     ENDCASE

      CASE f_ap:     cvfp(s_ap)		// a := a + P!n
                     ENDCASE
      CASE f_ag:     cvfg(s_ag)		// a := a + G!n
                     ENDCASE
      CASE f_a:      cvfk(s_a)		// a := a + n
                     ENDCASE
      CASE f_s:      cvfk(s_s)		// a := a - n
                     ENDCASE

      CASE f_lkp:    cvfkp(s_lkp)	// a := P!n!k
                     ENDCASE
      CASE f_lkg:    cvfkg(s_lkg)	// a := G!n!k
                     ENDCASE
      CASE f_rv:     cvf(s_rv)		// a := ! a
                     ENDCASE
      CASE f_rvp:    cvfp(s_rvp)	// a := P!n!a
                     ENDCASE
      CASE f_rvk:    cvfk(s_rvk)	// a := a!k
                     ENDCASE
      CASE f_st:     cvf(s_st)		// !a := b
                     ENDCASE
      CASE f_stp:    cvfp(s_stp)	// P!n!a := b
                     ENDCASE
      CASE f_stk:    cvfk(s_stk)	// a!n := b
                     ENDCASE
      CASE f_stkp:   cvfkp(s_stkp)	// P!n!k := a
                     ENDCASE
      CASE f_stkg:   cvfkg(s_skg)	// G!n!k := a
                     ENDCASE
      CASE f_xst:    cvf(s_xst)		// !b := a
                     ENDCASE

      CASE f_stb:    cvf("STB")		// %b := a
                     ENDCASE

      CASE f_lvind:  cvf("LVIND")	// a := @ b!a
                     ENDCASE

      CASE f_indb:   writef("F%n	K%n*n", s_atbl, 0)
                     cvf(s_gbyt)	// a := b % a
                     ENDCASE

      CASE f_indb0:  cvf(s_gbyt)	// a := % a
                     ENDCASE

      CASE f_indw:   cvf("INDW")	// a := b!a
                     ENDCASE

      CASE f_k:      cvfp(s_k)		// Call  a(b,...) incrementing P by n
                     ENDCASE
      CASE f_kpg:    cvfpg(s_kpg)	// Call Gg(a,...) incrementing P by n
                     ENDCASE

      CASE f_neg:    cvf(s_neg)		// a := - a
                     ENDCASE
      CASE f_not:    cvf(s_not)		// a := ~ a
                     ENDCASE
      CASE f_abs:    cvf(s_abs)		// a := ABS a
                     ENDCASE

      CASE f_xdiv:   cvf(s_xdiv)	// a := a / b
                     ENDCASE
      CASE f_xmod:   cvf("XMOD")	// a := a MOD b
                     ENDCASE
      CASE f_xsub:   cvf(s_xsub)	// a := a - b
                     ENDCASE

      CASE f_mul:    cvf(s_mul)		// a := b * a; c := ?
                     ENDCASE
      CASE f_div:    cvf(s_div)		// a := b / a; c := ?
                     ENDCASE
      CASE f_mod:    cvf(s_rem)		// a := b MOD a; c := ?
                     ENDCASE
      CASE f_add:    cvf(s_add)		// a := b + a
                     ENDCASE
      CASE f_sub:    cvf(s_sub)		// a := b - a
                     ENDCASE

      CASE f_eq:     cvf(s_eq) 		// a := b = a
                     ENDCASE
      CASE f_ne:     cvf(s_ne) 		// a := b ~= a
                     ENDCASE
      CASE f_ls:     cvf(s_ls) 		// a := b < a
                     ENDCASE
      CASE f_gr:     cvf(s_gr) 		// a := b > a
                     ENDCASE
      CASE f_le:     cvf(s_le) 		// a := b <= a
                     ENDCASE
      CASE f_ge:     cvf(s_ge) 		// a := b >= a
                     ENDCASE

      CASE f_eq0:    cvf(s_eq0) 	// a := a = 0
                     ENDCASE
      CASE f_ne0:    cvf(s_ne0) 	// a := a ~= 0
                     ENDCASE
      CASE f_ls0:    cvf(s_ls0)		// a := a < 0
                     ENDCASE
      CASE f_gr0:    cvf(s_gr0) 	// a := a > 0
                     ENDCASE
      CASE f_le0:    cvf(s_le0) 	// a := a <= 0
                     ENDCASE
      CASE f_ge0:    cvf(s_ge0) 	// a := a >= 0
                     ENDCASE

      CASE f_lsh:    cvf(s_lsh) 	// a := b << a
                     ENDCASE
      CASE f_lshk:   cvfk("LSHK")	// a := a << k 
                     ENDCASE
      CASE f_rsh:    cvf(s_rsh)		// a := b >> a 
                     ENDCASE
      CASE f_rshk:   cvfk("RSHK")	// a := a >> k 
                     ENDCASE
      CASE f_and:    cvf(s_and)		// a := b & a 
                     ENDCASE
      CASE f_or:     cvf(s_or)		// a := b | a 
                     ENDCASE
      CASE f_xor:    cvf(s_xor)		// a := b XOR a
                     ENDCASE

      CASE f_xch:    cvf(s_xch)		// swap a and b
                     ENDCASE
      CASE f_atb:    cvf(s_atb)		// b := a
                     ENDCASE
      CASE f_atc:    cvf(s_atc)		// c := a
                     ENDCASE
      CASE f_cta:    cvf("CTA")		// a := c
                     ENDCASE
      CASE f_bta:    cvf(s_bta)		// a := b
                     ENDCASE
      CASE f_btc:    cvf(s_btc)		// c := b
                     ENDCASE
      CASE f_atblp:  cvfp(s_atblp)	// b := a; a := P!n
                     ENDCASE
      CASE f_atblg:  cvfg(s_atblg)	// b := a; a := G!n
                     ENDCASE
      CASE f_atbl:   cvfk(s_atbl)	// b := a; a := k
                     ENDCASE

      CASE f_j:      cvfl(s_j)		// jump to Ln
                     ENDCASE
      CASE f_rtn:    cvf(s_rtn)		// procedure return
                     ENDCASE

      CASE f_ikp:    cvfkp(s_ikp)	// a := P!n + k; P!n := a
                     ENDCASE
      CASE f_ikg:    cvfkg(s_ikg)	// a := G!n + k; G!n := a
                     ENDCASE
      CASE f_ikl:    cvfkl(s_ikl)	// a := !Ln + k; !Ln := a
                     ENDCASE
      CASE f_ip:     cvfp(s_ip)		// a := P!n + a; P!n := a
                     ENDCASE
      CASE f_ig:     cvfg(s_ig)		// a := G!n + a; G!n := a
                     ENDCASE
      CASE f_il:     cvfl(s_il)		// a := !Ln + a; !Ln := a
                     ENDCASE

      CASE f_jeq:    cvfl(s_jeq)	// Jump to Ln if b = a
                     ENDCASE
      CASE f_jne:    cvfl(s_jne)	// Jump to Ln if b ~= a
                     ENDCASE
      CASE f_jls:    cvfl(s_jls)	// Jump to Ln if b < a
                     ENDCASE
      CASE f_jgr:    cvfl(s_jgr)	// Jump to Ln if b > a
                     ENDCASE
      CASE f_jle:    cvfl(s_jle)	// Jump to Ln if b <= a
                     ENDCASE
      CASE f_jge:    cvfl(s_jge)	// Jump to Ln if b >= a
                     ENDCASE

      CASE f_jeq0:   cvfl(s_jeq0)	// Jump to Ln if a = 0
                     ENDCASE
      CASE f_jne0:   cvfl(s_jne0)	// Jump to Ln if a ~= 0
                     ENDCASE
      CASE f_jls0:   cvfl(s_jls0)	// Jump to Ln if a < 0
                     ENDCASE
      CASE f_jgr0:   cvfl(s_jgr0)	// Jump to Ln if a > 0
                     ENDCASE
      CASE f_jle0:   cvfl(s_jle0)	// Jump to Ln if a <= 0
                     ENDCASE
      CASE f_jge0:   cvfl(s_jge0)	// Jump to Ln if a >= 0
                     ENDCASE

      // The following five opcodes are never generated by
      // the BCPL compiler
      CASE f_brk:    cvf(s_brk)		// Breakpoint instruction
                     ENDCASE
      CASE f_nop:    cvf(s_nop)		// No operation
                     ENDCASE
      CASE f_chgco:  cvf(s_chgco)	// Change coroutine
                     ENDCASE
      CASE f_mdiv:   cvf(s_mdiv)	// a := Muldiv(P!3, P!4, P!5) 
                     ENDCASE
      CASE f_sys:    cvf(s_sys)		// System function
                     ENDCASE

      CASE f_module:   cvfs(s_section)	// Name of section
                       FOR i = 0 TO charv%0 DO modname%i := charv%i
                       ENDCASE
      CASE f_modstart: cvf(s_modstart)	// Start of module  
                       modname%0 := 0
                       ENDCASE
      CASE f_modend:   cvf(s_modend)	// End of module 
                       modletter := modletter+1
                       ENDCASE
      CASE f_global:   cvglobal()	// Global initialisation data
                       ENDCASE
      CASE f_const:    cvconst()	// Large integer constant
                       ENDCASE
      CASE f_lab:      cvfl(s_lab)	// Program label
                       ENDCASE
      CASE f_entry:    cventry()	// Start of a function
                       ENDCASE

      CASE f_dlab:     cvstring(s_string)		// Static data label
                       ENDCASE
      CASE f_dw:       cvfw("DW")	// Static data word
                       ENDCASE
      CASE f_db:       cvfk("DB")	// Static data byte
                       ENDCASE
      CASE f_dl:       cvfl("DL")	// Static data word pointer
                       ENDCASE
      CASE f_ds:       cvfk("DS")	// Static data space
                       ENDCASE

      CASE f_inc1b:    cvf("INC1B")	// a := ++(!a)
                       ENDCASE
      CASE f_inc4b:    cvf("INC4B")	// a := +++(!a)
                       ENDCASE
      CASE f_dec1b:    cvf("DEC1B")	// a := --(!a)
                       ENDCASE
      CASE f_dec4b:    cvf("DEC4B")	// a := ---(!a)
                       ENDCASE
      CASE f_inc1a:					// a := (!a)++
                       cvf(s_atb); newline()			// b := a			save address of location to be incremented
                       cvf(s_rv); newline()				// a := ! a			get value to be incremented
                       writef("F%n	K%n*n", s_a, 1)		// a := a + n		increment it...
					   cvf(s_xst)						// !b := a			...and save it
                       ENDCASE

      CASE f_inc4a:    cvf("INC4A")	// a := (!a)+++
                       ENDCASE
      CASE f_dec1a:    cvf("DEC1A")	// a := (!a)--
                       ENDCASE
      CASE f_dec4a:    cvf("DEC4A")	// a := (!a)---
                       ENDCASE

      CASE f_unh:      cvf("UNH")	// h := h!1
                       ENDCASE

      CASE f_hand:     cvfl("HAND") // a!0, a!1, a!2 := P, H, Ln
                                    // H := a
                       ENDCASE

      CASE f_raise:    LOOP							//	...to avoid extra 'newline()'
                       ENDCASE

   $)

   newline()
$) REPEAT

AND cvf(s)   BE writef("F%n", s)
AND cvfp(s)  BE writef("F%n	P%n", s, rdp())
AND cvfkp(s) BE writef("F%n	K%n P%n", s, rdk(), rdp())
AND cvfg(s)  BE writef("F%n	G%n", s, rdg())
AND cvfkg(s) BE writef("F%n	K%n G%n", s, rdk(), rdg())
AND cvfkl(s) BE writef("F%n	K%n L%n", s, rdk(), rdl())
AND cvfpg(s) BE writef("F%n	P%n G%n", s, rdp(), rdg())
AND cvfk(s)  BE writef("F%n	K%n", s, rdk())
AND cvfw(s)  BE writef("F%n	W%n", s, rdw())
AND cvfl(s)  BE
$(//	LET c1, c2, c3, lab = getbyte(s, 1), getbyte(s, 2), getbyte(s, 3), FALSE
  //	IF (c1='D' | c1='L') & NOT (c2='F' | c3='L') THEN lab := TRUE
   writef("F%n	L%n", s, rdl())
$)
AND cvfm(s)  BE writef("F%n	M%n", s, rdm())

AND cvglobal() BE
$( LET n = rdk()
   writef("F%n K%n*n", s_global, n)
   IF modname%0=0 FOR i = 0 TO 4 DO modname%i := "prog"%i
   FOR i = 1 TO n DO
   $( LET g = rdg()
      LET n = rdl()
      writef("G%n L%n*n", g, n)
   $)
   writef("G%n", rdg())
$)

AND rdchars() = VALOF
{ LET n = rdk()
  charv%0 := n
  FOR i = 1 TO n DO charv%i := rdc()
  RESULTIS n
}

AND cvconst() BE
$( LET lab = rdm()
   LET w = rdw()
   writef("CONST   M%n W%n", lab, w)
$)

AND cvfs(s) BE
$( LET n = rdchars()
   writef("F%n	K%n", s, n)
   FOR i = 1 TO n DO writef(" C%n", charv%i)
$)

AND cvstring() BE
$( LET lab = rdl()
   AND i, ch = 0, ?
   writef("F%n	M%n ", s_string, lab)
   charv%0 := i
   $( LET op = rdf()							//	this must be f_db...
	  i := i+1
      ch := rdk()
	  charv%i := ch
   $) REPEATUNTIL ch=0							//	...in mial strings are null-terminated
   charv%0 := i
   writef("K%n", i); FOR j=1 TO i DO writef(" C%n", charv%j)
$)

AND cventry() BE
$( LET n = rdchars()
   LET op = rdf()
   LET lab = rdl()
 //writef("*nEntry to: %s*n", charv)
   writef("*nF%n	K%n", s_entry, n)
   FOR i = 1 TO n DO writef(" C%n", charv%i)
   newline()
   TEST op=f_lab THEN writef("F%n	L%n", s_lab, lab)
                 ELSE writef("Bad op F%n L%n", op, lab)
$)




