
GET "libhdr"

LET start() BE {
  LET pi=3.1415927410
  LET dec=1000.0
  LET dec2=39887.5625
  LET negint, circum=-42, ?
  LET x=?

  x := FIX (pi #* dec)
  writef("  pi=%32b*n", FIX (pi #* dec))

  x := FLOAT 100
  writef("pi=%n (again:%n), and an integer=%n*n", pi, 3.1415927410, negint)
  writef("pi is %s pi, and %s dec2*n", pi #~= pi -> "not equal to", "equal to", pi #< dec2 -> "less than", "greater or equal to")
  circum := pi #* 6.2
  writef("circum=%1.3d*n", FIX (circum #* dec))
  writef("   dec=%n*n", FIX dec)
  writef("  dec2=%n*n", FIX dec2)
		//	If we're using the standard blib, then enable the next few lines...
/*	writes("    pi=")
 *	printfp(pi, 6); writes(", x=")
 *	printfp(x, 0); newline()
 *	x := x #- 10.0
 *	printfp(x, 0); newline()
 *	x := x #/ 10.0
 *	printfp(x, 0); newline()
 *	printfp(x, 2); newline()
 *	printfp(#-x, 2); newline()
 */
		//	...otherwise if using the latest blib, this will work!
  writef("    pi=%r6, x=%r0*n", pi, x)
  writef("    x=%r1	(%n)*n", x, FIX x)
  writef("    x=%r4*n", x #/ 3.0)
  writef("   -x=%r2*n", #-x)
}

AND printfp(fpnum, decplaces) BE {
  LET v = VEC 20
  LET i = 0
  LET k, m, neg = ?, 1.0, 0
  FOR j=1 TO decplaces DO m := m #* 10.0
  k := FIX (fpnum #* m)
writef("k=%n*n", k)
  TEST k<0 THEN neg := 1 ELSE k := -k
  v!i, k, i := k REM 10, k/10, i+1 REPEATUNTIL k=0
  IF neg DO wrch('-')
  FOR j = i-1 TO 0 BY -1 DO {
    wrch('0'-v!j)
    IF j=decplaces UNLESS j=0 wrch('.')
  }
}
