// Copyright (c) 2012 Dave Cannon.  All rights reserved.

// $Id: su.s,v 1.2 28-Sep-2012 13:04:12 rn Exp $
	.file	"su.s"

#	.set DEBUG,1								# enable/disable comprehensive diagnostics output
#	.set TEST_ARGS,1							# set known values to be passed as argv and argc to BCPL START()

				.set	START,1
				.set	STACKBASE,95
				.set	STACKEND,96
				.set	STKSIZ,0x400000
				
				.global _initbcpl
				.global finish
				.global stop


	.section .rdata,"dr"
LCc:
	.ascii "\11\11buff:[%d] = %d\12\0"
	.text
_initbcpl:
#	calling parameters:
#			4(%esp)		# argc...
#			8(%esp)		# ...address of argv[]

				cld
#
				pushl %ebp
				movl %esp, %ebp
				subl $24, %esp			# set up top of frame
				call _rtinit			# run-time initialisation of BCPL file table
#
.ifdef DEBUG
#			start diagnostics...
				call _stacktrace
#			end diagnostics...
.endif
				movl STACKBASE*4(%edi),%eax			# collect GLOBAL vector 95 (STACKBASE)
				shll $2,%eax						# convert BCPL word to byte address
										# set up stack for return from user's START() routine
				movl %eax, %ebp			# prepare BCPL stack...
                movl $0,(%ebp)			# (no previous value for %ebp!)
				movl $finish,4(%ebp)	# ...for return to finish()
				movl 36(%esp),%eax		# collect argv[]
				movl %eax,8(%ebp)		# ...argv[]
.ifdef TEST_ARGS
#			start diagnostics...
				movl $666,8(%ebp)		# **test**
#			end diagnostics...
.endif
                movl 32(%esp),%eax		# collect argc
				movl %eax,12(%ebp)		# ...argc
.ifdef TEST_ARGS
#			start diagnostics...
				movl $333,12(%ebp)		# **test**
#			end diagnostics...
.endif
                mov 4(%edi),%eax		# collect user's START() address from GLOBAL 1
                jmp *%eax				# jump to START()

finish:         xor %eax,%eax
stop:           push %eax
                call _rtexit
                call _exit				# no need for what follows...
#				leave
#				ret
