// $Id: LIBHDR,v 3.0 2020/08/02 22:00:12 rn Exp $

//  libhdr	- 'libhdr.h' as amended for the University of Essex compiler:	2-Aug-2020

EXTERNAL $(
	fwritef
$)

GLOBAL $(
start			: 1
sys				: 2
abort			: 3					// Calls BACKTRACE and MAPSTORE
backtrace		: 4
stacktrace		: 4					// Summarise the run-time stack
trap			: 5

selectinput		: 11
selectoutput	: 12
rdch			: 13
wrch			: 14
unrdch			: 15
input			: 16
output			: 17

timeofday		: 27
time			: 28
date			: 29
stop			: 30
level			: 31
longjump		: 32
rewind			: 35

aptovec			: 40
findoutput		: 41
findinput		: 42
findappend		: 43
endstream		: 45
endread			: 46
endwrite		: 47
filetable		: 48							// for diagnostics: 24-oct-2012
rename			: 49
delete			: 50
endtoinput		: 51
getenv			: 52
pathfindinput	: 53
findfile		: 54
fseek			: 55

writes			: 60
writen			: 62
newline			: 63
newpage			: 64
packstring		: 66
unpackstring	: 67
writed			: 68
readn			: 70
terminator		: 71

capitalch		: 74
writehex		: 75
writef			: 76
writeoct		: 77
mapstore		: 78
swritef			: 79

getbyte			: 85
putbyte			: 86
getvec			: 87
freevec			: 88

rdargs			: 90
result2			: 91
strcat			: 92
str2no			: 93
str2numb		: 94
stackbase		: 95
stackend		: 96
argc			: 97
argv			: 98
param			: 99
$)


MANIFEST $(
sysin			= 0
sysout			= 1
syserr			= 2				// Standard input, output and error streams (preopened, set to console)

endstreamch		= -1
bytesperword	= 4
bitsperword		= 32
maxstrlength	= 255

maxint			= #X7FFFFFFF
minint			= #X80000000

neggsz			= 32			// limit of negative GLOBAL numbers
firstfreeglobal	= 100
ug = firstfreeglobal
$)
